Attribute VB_Name = "CodePage"
Option Explicit
'** Declaration Section - Types
Type RECT                               'Used by GetClientRect and GetWindowRect
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Type OsVersionInfo
    dwVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatform As Long
    szCSDVersion As String * 128
End Type

Type Critter                           'Define Sprite User Defined Object
    FrIndex As Integer                 'Current Frame Index
    Xp As Integer                      'X Position on Display Screen
    Yp As Integer                      'Y Postion on Display Screen
    Width As Integer                   'Width of Critter in pixels
    Height As Integer                  'Height of Critter in pixels
    Xmove As Integer                   'Amount to Move Horizontally
    Ymove As Integer                   'Amount to move Vertically
    Frames As Integer                  'Amount of Frames in Sprite Set
    Show As Boolean                    'Display or not to display (true=display)
    ImageSrcX(4) As Integer            'X Position in Source File Main Image
    ImageSrcY(4) As Integer             'y Position in Source File Main Image
    ImageMaskX(4) As Integer            'X Position in Source File Main Image (mask)
    ImageMaskY(4) As Integer            'y Position in Source File Main Image (mask)
    FrameDelay As Integer
    EventTime As Integer
End Type

'** Private Variables
Private Ind As Integer
Private destX As Long                'Destination X Position
Private destY As Long                'Destination Y Position
Private srcDC As Long                'Source DC
Private SpCnt As Integer             'Counter used for Cylcing Sprites
'Private dest As Control
Private CPWindow&
Private OsVers As OsVersionInfo
Private Const HWND_TOPMOST = -1
Private Const HKEY_CURRENT_USER = &H80000001
Private Const SPI_SCREENSAVERRUNNING = 97&

'** Public Variables
Public RightX As Integer               'Right Screen Limit
Public BottomY As Integer
Public SpriteCount As Integer       'Critter Set Count
Public ASpeed As Integer
Public BlankScreen As Integer
Public UFOs As Integer

Public Started As Boolean
Public winOS&
Public Const WinNT = 2&
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = 1
Public Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE

Public PwdOn As Boolean
Public PWProtect%
Public MouseX As Integer
Public MouseY As Integer

'** Create # of Critter Sprite Objects
Public Sprites(50) As Critter       'Change Number to amount of Sprites

'** API declarations
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateDC& Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName$, ByVal lpDeviceName$, ByVal lpOutput$, ByVal lpInitData&)
Private Declare Function FindWindow& Lib "user32" Alias "FindWindowA" (ByVal lpClassName$, ByVal lpWindowName$)
Private Declare Function GetVersionEx& Lib "kernel32" Alias "GetVersionExA" (lpStruct As OsVersionInfo)
Private Declare Function PwdChangePassword& Lib "mpr" Alias "PwdChangePasswordA" (ByVal lpcRegkeyname$, ByVal hwnd&, ByVal uiReserved1&, ByVal uiReserved2&)
Private Declare Function RegCloseKey& Lib "advapi32.dll" (ByVal HKey&)
Private Declare Function RegOpenKeyExA& Lib "advapi32.dll" (ByVal HKey&, ByVal lpszSubKey$, dwOptions&, ByVal samDesired&, KeyHandle&)
Private Declare Function RegQueryValueExA& Lib "advapi32.dll" (ByVal HKey&, ByVal lpszValueName$, lpdwRes&, lpdwType&, ByVal lpDataBuff$, nSize&)
Private Declare Sub Sleep Lib "kernel32" (ByVal milliseconds As Long)
Public Declare Function StretchBlt& Lib "gdi32" (ByVal hDestDC&, ByVal X&, ByVal Y&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal XSrc&, ByVal YSrc&, ByVal nSrcWidth&, ByVal nSrcHeight&, ByVal dwRop&)
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Public Declare Function timeGetTime Lib "winmm.dll" () As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal h&, ByVal hb&, ByVal X&, ByVal Y&, ByVal cx&, ByVal cy&, ByVal f&) As Long
Public Declare Function ShowCursor& Lib "user32" (ByVal bShow&)
Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long
Public Declare Function VerifyScreenSavePwd Lib "password.cpl" (ByVal hwnd&) As Boolean

'** Registry permission
Private Const KEY_QUERY_VALUE = &H1&
Private Const KEY_ENUMERATE_SUB_KEYS = &H8&
Private Const KEY_NOTIFY = &H10&
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const Key_Read = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const REG_DWORD = 4&

'** BitBlt Variables and constants
Private Const SRCAND = &H8800C6
Public Const SRCCOPY = &HCC0020
Private Const SRCPAINT = &HEE0086
Private Const NOTSRCCOPY = &H330008

Public Xo As Long
Public Yo As Long
Public Xs As Long
Public Ys As Long
Public XSrc As Long
Public YSrc As Long
Public DDC As Long
Public SDC As Long
Public res As Long
'Set Debugging to true in Initialization() when working on code
Public Debugging As Boolean

Sub GetVersion32() 'used to figure out what operating system we're running on
    'needed only for the password dialog box (nt doesn't use one)
    OsVers.dwVersionInfoSize = 148&
    GetVersionEx OsVers
    winOS = OsVers.dwPlatform
End Sub

Function RegGetValue$(MainKey&, SubKey$, value$)
   Dim KeyType&           'key type
   Dim RetVal&            'return value = 0
   Dim KeyHandle&         'handle of open key
   Dim DataLength&        'length of data returned
   Dim ReturnedString$    'returned value
    Dim fTempDbl!
   If MainKey >= &H80000000 And MainKey <= &H80000006 Then
      ' Open key
      RetVal = RegOpenKeyExA(MainKey, SubKey, 0&, Key_Read, KeyHandle)
      If RetVal <> 0 Then
         RegGetValue = ""
         Exit Function     'No key exists
         End If
      
      ' Data buffer
      DataLength = 255
      ReturnedString = Space$(DataLength)

      ' Read the key
      RetVal& = RegQueryValueExA(KeyHandle, value, ByVal 0&, KeyType, ReturnedString, DataLength)
      If RetVal <> 0 Then
         RegGetValue = ""
      Else
        If KeyType = REG_DWORD Then
            fTempDbl = Asc(Mid$(ReturnedString, 1, 1)) + &H100& * Asc(Mid$(ReturnedString, 2, 1)) + &H10000 * Asc(Mid$(ReturnedString, 3, 1)) + &H1000000 * CDbl(Asc(Mid$(ReturnedString, 4, 1)))
            ReturnedString = Format$(fTempDbl, "000")
        End If
        RegGetValue = Left$(ReturnedString, DataLength - 1)
    End If
      ' close the key
      RetVal = RegCloseKey(KeyHandle)
   End If
End Function

Sub CopyScreen(canvas As Object)
    Dim screendc&
    canvas.AutoRedraw = True
    screendc = CreateDC("DISPLAY", "", "", 0&)
    StretchBlt canvas.hdc, 0, 0, canvas.Width, canvas.Height, screendc, 0, 0, Screen.Width, Screen.Height, SRCCOPY
    DeleteDC screendc
    canvas.AutoRedraw = False

End Sub

Sub Main()
  
Dim StartType$

BlankScreen = GetSetting("DJPsoftware", "ufosaver", "BlankScreen", "1")
ASpeed = Val(GetSetting("DJPsoftware", "ufosaver", "ASpeed", "20"))
UFOs = Val(GetSetting("DJPsoftware", "ufosaver", "UFOs", "25"))

SpriteCount = UFOs
     
    StartType = UCase(Left$(Command, 2))
    If StartType = "" Then
        'default load mode - configuration (user right clicked)
        StartType = "/C"
    End If
    Select Case StartType
        Case "/C"
            Configuration.Show
        Case "/S"
            'Routine to see if screen saver  is running already
            If CheckUnique("UFOsaver") = False Then
                Exit Sub
            End If
            'If not then Start Initializing everything
            Load MainForm
            MainForm.Width = Screen.Width
            MainForm.Height = Screen.Height
            Initialize
             
       Case "/P"
            'Do Preview
            If App.PrevInstance Then End
            Preview.Show

        Case "/A"
            'Get Config handle
            CPWindow = Val(Right$(Command, Len(Command) - 2))
            PwdChangePassword "SCRSAVE", CPWindow, 0, 0
    End Select

End Sub
Function CheckUnique%(FormCaption$)
    'looks for a window with the same caption
    Dim HandleWin&
    HandleWin = FindWindow(vbNullString, FormCaption)
    If HandleWin = 0 Then
        CheckUnique = True
    Else
        CheckUnique = False
    End If
End Function
Sub Controller()

Do
DoAnimation
If ASpeed > 0 Then Sleep (ASpeed)
DoEvents
Loop

End Sub

Sub DoAnimation()

'Reset Background
DDC = WorkPage.WorkScr.hdc
SDC = WorkPage.CleanScreen.hdc

For SpCnt = 0 To SpriteCount - 1
With Sprites(SpCnt)

    Xo = .Xp
    Yo = .Yp
    Xs = .Width
    Ys = .Height
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, Xo, Yo, SRCCOPY)
End With
Next

For SpCnt = 0 To SpriteCount - 1
With Sprites(SpCnt)

    .FrameDelay = .FrameDelay + 1
    If .FrameDelay > 5 Then
        .FrIndex = .FrIndex + 1
        If .FrIndex > 3 Then .FrIndex = 0
        .FrameDelay = 0
    End If
    
    If .Yp > BottomY Then
        .Ymove = Int(Rnd * 8) + 1
        .Yp = 0
    End If
    If .Yp <= -60 Then
        .Ymove = -(Int(Rnd * 8) + 1)
        .Yp = BottomY
    End If
    If .Xp > RightX Then
        .Xmove = Int(Rnd * 8) + 1
        .Xp = -90
    End If
    If .Xp < -100 Then
        .Xmove = -(Int(Rnd * 8) + 1)
        .Xp = RightX
    End If
    
    
    If .Xmove = 0 Or .Ymove = 0 Then
        .Ymove = 1
        .Xmove = 1
    End If
    
    .EventTime = .EventTime + 1
    If .EventTime >= 500 Then
        .EventTime = 0
        .Ymove = .Ymove * -1
    End If
    If .EventTime = 250 Then
        .Xmove = .Xmove * -1
    End If
    
    .Xp = .Xp + .Xmove
    .Yp = .Yp + .Ymove
    
    'And mask to WorkScr
    Ind = .FrIndex
    Xo = .Xp
    Yo = .Yp
    Xs = .Width
    Ys = .Height
    XSrc = .ImageMaskX(Ind)
    YSrc = .ImageMaskY(Ind)
    DDC = WorkPage.WorkScr.hdc
    SDC = WorkPage.Master.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCAND)

    'Or image to WorkScr
    XSrc = .ImageSrcX(Ind)
    YSrc = .ImageSrcY(Ind)
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCPAINT)
End With
Next

'copy all sprites to screen
For SpCnt = 0 To SpriteCount
With Sprites(SpCnt)
    Xo = .Xp
    Yo = .Yp
    Xs = .Width
    Ys = .Height
    DDC = MainForm.hdc
    SDC = WorkPage.WorkScr.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, Xo, Yo, SRCCOPY)
End With
Next

End Sub

Sub Initialize()
Dim DestDC As Long               'Destination DC
Dim XPixels As Long              'Transfer Picture Width
Dim YPixels As Long              'Trandfer Picture Height
Dim destX As Long                'Destination X Position
Dim destY As Long                'Destination Y Position
Dim srcDC As Long                'Source DC
Dim SrcX As Long                 'Source X Position
Dim SrcY As Long                 'Source Y Position
Dim RasterOp As Long             'Raster Operation to Perform (Copy, And, Or)
Dim ZName As String

Debugging = False 'set to true if you are working on the code. Set to false before compliling to .scr

'Make the screen saver a TOPMOST window
If Debugging = False Then SetWindowPos MainForm.hwnd, HWND_TOPMOST, 0, 0, 0, 0, FLAGS

MainForm.WindowState = 2

BottomY = MainForm.ScaleHeight     'Set Bottom Screen Limit
RightX = MainForm.ScaleWidth       'Set Right Screen Limit

'Copy a clone of the desktop onto the form, to
'serve as a background if the option is chosen in the config screen
If BlankScreen <> 1 Then CopyScreen MainForm


Dim z As Long
Dim r As Integer
Randomize (Timer)
For z = 0 To SpriteCount - 1
With Sprites(z)
    .Xp = Int(Rnd * (RightX - 100))
    .Yp = Int(Rnd * (BottomY - 100))
    .Xmove = (5 - Int(Rnd * 10)) + 1
    .Ymove = (6 - Int(Rnd * 10)) + 1
    .Width = 100
    .Height = 62
    .FrIndex = Int(Rnd * 3)
    .EventTime = Int(Rnd * 500)
    .Show = True
    .Frames = 3
    .ImageSrcX(0) = 0   'frame1
    .ImageSrcY(0) = 0
    .ImageSrcX(1) = 100
    .ImageSrcY(1) = 0   'frame2
    .ImageSrcX(2) = 200
    .ImageSrcY(2) = 0   'frame3
    .ImageSrcX(3) = 300
    .ImageSrcY(3) = 0   'frame4
    
    .ImageMaskX(0) = 0   'frame1 mask
    .ImageMaskY(0) = 62
    .ImageMaskX(1) = 100 'frame2 mask
    .ImageMaskY(1) = 62
    .ImageMaskX(2) = 200 'frame3 mask
    .ImageMaskY(2) = 62
    .ImageMaskX(3) = 300 'frame4 mask
    .ImageMaskY(3) = 62
    
End With

Next
    If Debugging = False Then
        'Find out from the System Registry if the user
        'has enabled password protection for screen savers.
        PWProtect = Val(RegGetValue(HKEY_CURRENT_USER, "Control Panel\Desktop", "ScreenSaveUsePassword"))
      
        'Find out if we are running under NT
        GetVersion32
    
        'Disable Ctrl-Alt-Del if appropriate.

        If PWProtect And winOS <> WinNT Then
        SystemParametersInfo SPI_SCREENSAVERRUNNING, 1&, 0&, 0&
        End If

        'Make the cursor go away
        Do
        Loop Until ShowCursor(False) < -5

    End If
    
    'Make sure we get random positions
    Randomize (Timer)

    'init all of the screens (workpage, cleanscreen and display screen)
    MainForm.Show
    MainForm.WindowState = 2
    '** Make Capture and WorkSpace Screens are the same size as MainForm Screen
    WorkPage.CleanScreen.Width = MainForm.Width
    WorkPage.CleanScreen.Height = MainForm.Height
    WorkPage.WorkScr.Width = MainForm.Width
    WorkPage.WorkScr.Height = MainForm.Height
    MainForm.Refresh                        'Make sure MainForm is current

    If BlankScreen = 1 Then
        Dim zz As Integer
        For zz = 1 To 300
        MainForm.PSet (Int(Rnd * RightX), Int(Rnd * BottomY)), QBColor(15)
        If zz < 25 Then MainForm.PSet (Int(Rnd * RightX), Int(Rnd * BottomY)), QBColor(11)
        
        Next
    End If
    
    DoEvents

    '** Copy MainForm Page to Capture Screen
    DestDC = WorkPage.CleanScreen.hdc
    destX = 0
    destY = 0
    XPixels = MainForm.ScaleWidth
    YPixels = MainForm.ScaleHeight
    srcDC = MainForm.hdc
    SrcX = 0
    SrcY = 0
    RasterOp& = SRCCOPY
    BitBlt DestDC, destX, destY, XPixels, YPixels, srcDC, SrcX, SrcY, RasterOp

    WorkPage.CleanScreen.Refresh

    '** Copy MainForm to WorkSpace Screen
    DestDC = WorkPage.WorkScr.hdc
    XPixels = MainForm.ScaleWidth
    YPixels = MainForm.ScaleHeight
    srcDC = MainForm.hdc
    SrcX = 0
    SrcY = 0
    RasterOp& = SRCCOPY
    BitBlt DestDC, 0, 0, XPixels, YPixels, srcDC, SrcX, SrcY, RasterOp

    WorkPage.WorkScr.Refresh
    On Error Resume Next

    Started = True
    Controller  'Start it up and make it run

End Sub
