Attribute VB_Name = "CodePage"
'Note - this verison uses one more buffering technique.  Normal you must have blank
'space around each of your sprite pictures.  If your graphic will move at 8 pixel
'intervals, then you must have at least 8 pixels of black area completly around
'your image.  The code here eliminates the need for that blank area by double buffering
'the image (creating it's own blank area).  This source is set up so that the sprite
'can only move a max of 10 pixels at a time to keep trails off of the screen.  Also
'please note that it is better to have a blank area around your sprite instead of using
'this method since double buffering will slow it down just a tad.

Option Explicit
'** Declaration Section - Types
Type Critter                           'Define Sprite User Defined Object
    FrIndex As Integer                 'Current Frame Index
    Xp As Integer                      'X Position on Display Screen
    Yp As Integer                      'Y Postion on Display Screen
    Width As Integer                   'Width of Critter in pixels
    Height As Integer                  'Height of Critter in pixels
    Xmove As Integer                   'Amount to Move Horizontally
    Ymove As Integer                   'amount to move vertically
    Frames As Integer                  'Amount of Frames in Sprite Set
    Show As Boolean                    'Display or not to display (true=display)
    ImageSrcX(3) As Integer            'X Position in Source File Main Image
    ImageSrcY(3) As Integer            'Y Position in Source File Main Graphic
    ImageMaskX(3) As Integer           'X Position in Source File Main Image (Mask)
    ImageMaskY(3) As Integer           'Y Position in Source File Main Graphic (Mask)
    EventCount As Integer              'determines when an event should occur
    
End Type

'** Create # of Critter Sprite Objects
Private Sprites(40) As Critter         'Change Number to amount of Sprites needed
Private SpCnt As Integer               'Counter used for Cylcing through Sprites
Public RightX As Integer              'Right Screen Limit
Public BottomY As Integer
Private SpriteCount As Integer         'Critter Set Count
Public ASpeed As Integer              'Animation Speed

'** API declarations
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateDC& Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName$, ByVal lpDeviceName$, ByVal lpOutput$, ByVal lpInitData&)
Private Declare Sub Sleep Lib "kernel32" (ByVal milliseconds As Long)
Private Declare Function StretchBlt& Lib "gdi32" (ByVal hDestDC&, ByVal x&, ByVal y&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal XSrc&, ByVal YSrc&, ByVal nSrcWidth&, ByVal nSrcHeight&, ByVal dwRop&)
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Public Const SRCAND = &H8800C6
Public Const SRCCOPY = &HCC0020
Public Const SRCPAINT = &HEE0086
Public Const NOTSRCCOPY = &H330008

'** BitBlt Variables
Private Ind As Long
Private Xo As Long
Private Yo As Long
Private Xs As Long
Private Ys As Long
Private XSrc As Long
Private YSrc As Long
Private DDC As Long
Private SDC As Long
Private res As Long

Sub CopyScreen(canvas As Object)
Dim screendc&
canvas.AutoRedraw = True
screendc = CreateDC("DISPLAY", "", "", 0&)
StretchBlt canvas.hdc, 0, 0, canvas.Width, canvas.Height, screendc, 0, 0, Screen.Width, Screen.Height, SRCCOPY
DeleteDC screendc
canvas.AutoRedraw = False

End Sub

Sub Main()
  
ASpeed = 20 '**** this will change the speed of the animation (< faster, > slower)
SpriteCount = 40 ' the amount of sprites to show on the screen

initialize

Controller  ' Startup the animation (controller routine below)

End Sub
Sub Controller()

Do
'this would normally be set from the registry
DoAnimation 'do it to it
DoEvents 'allows system to check and see if key was pressed or mouse was clicked
If ASpeed > 0 Then Sleep (ASpeed) 'delay to slow down the animation
Loop

End Sub

Sub DoAnimation()

'Reset Background
DDC = WorkPage.WorkScr.hdc
SDC = WorkPage.CleanScreen.hdc

For SpCnt = 0 To SpriteCount - 1 ' Erase all Sprites from screen
With Sprites(SpCnt)
    Xo = .Xp
    Yo = .Yp
    Xs = 50
    Ys = 50
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, Xo, Yo, SRCCOPY)
End With
Next

For SpCnt = 0 To SpriteCount - 1 'loop through and move each sprite
With Sprites(SpCnt)
    .EventCount = .EventCount + 1 'Frame animation rate delay
    If .EventCount > 4 Then
        .FrIndex = .FrIndex + 1 'default standing position
        If .FrIndex > .Frames - 1 Then .FrIndex = 0
        .EventCount = 0
    End If
    If .Yp >= BottomY - 30 Then .Ymove = -((Rnd * 7) + 2)
    If .Yp < -10 Then .Ymove = (Rnd * 7) + 2
    If .Xp >= RightX - .Width - 10 Then .Xmove = -((Rnd * 7) + 2)
    If .Xp < -10 Then .Xmove = (Rnd * 7) + 2
    
    .Xp = .Xp + .Xmove
    .Yp = .Yp + .Ymove

    'copy to temp mask sizer '****** New (used to add a blank border around mask)
    Ind = .FrIndex
    Xo = 10
    Yo = 10
    Xs = .Width
    Ys = .Height
    XSrc = .ImageMaskX(Ind)
    YSrc = .ImageMaskY(Ind)
    DDC = WorkPage.TempMask.hdc
    SDC = WorkPage.Master.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCCOPY)
    
    'copy to temp sprite sizer '****** New (used to add a blank border around sprite)
    Ind = .FrIndex
    Xo = 10
    Yo = 10
    Xs = .Width
    Ys = .Height
    XSrc = .ImageSrcX(Ind)
    YSrc = .ImageSrcY(Ind)
    DDC = WorkPage.TempSprite.hdc
    SDC = WorkPage.Master.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCCOPY)
    
    'And mask to WorkScr
    Ind = .FrIndex
    Xo = .Xp
    Yo = .Yp
    Xs = 50
    Ys = 50
    XSrc = 0
    YSrc = 0
    DDC = WorkPage.WorkScr.hdc
    SDC = WorkPage.TempMask.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCAND)
    
    'Or image to WorkScr
    SDC = WorkPage.TempSprite.hdc
    XSrc = 0
    YSrc = 0
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCPAINT)
End With
Next

'copy all sprites to screen
For SpCnt = 0 To SpriteCount - 1
With Sprites(SpCnt)
    Xo = .Xp
    Yo = .Yp
    Xs = 50
    Ys = 50
    DDC = MainForm.hdc
    SDC = WorkPage.WorkScr.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, Xo, Yo, SRCCOPY)
End With
Next

End Sub

Sub initialize()

'** copying screen Variables
Dim DestDC As Long               'Destination DC
Dim XPixels As Long              'Transfer Picture Width
Dim YPixels As Long              'Trandfer Picture Height
Dim destX As Long                'Destination X Position
Dim destY As Long                'Destination Y Position
Dim srcDC As Long                'Source DC
Dim SrcX As Long                 'Source X Position
Dim SrcY As Long                 'Source Y Position
Dim RasterOp As Long             'Raster Operation to Perform (Copy, And, Or)

MainForm.Show                       'Bring up the main display form
MainForm.WindowState = 2            ' make sure it's maximized
BottomY = MainForm.ScaleHeight     'Set Bottom Screen Limit
RightX = MainForm.ScaleWidth       'Set Right Screen Limit

CopyScreen MainForm                'Get the Desktop window as a background


'** Make CleanScreen and WorkSpace Screens are the same size as MainForm Screen
WorkPage.CleanScreen.Width = MainForm.Width
WorkPage.CleanScreen.Height = MainForm.Height
WorkPage.WorkScr.Width = MainForm.Width
WorkPage.WorkScr.Height = MainForm.Height
MainForm.Refresh  'Make sure MainForm is current

DoEvents

'** Copy MainForm Page to Clean Screen
'** this saves us a clean background to refresh from when restoring the background undeneath a sprite
DestDC = WorkPage.CleanScreen.hdc
destX = 0
destY = 0
XPixels = MainForm.ScaleWidth
YPixels = MainForm.ScaleHeight
srcDC = MainForm.hdc
SrcX = 0
SrcY = 0
RasterOp& = SRCCOPY
BitBlt DestDC, destX, destY, XPixels, YPixels, srcDC, SrcX, SrcY, RasterOp
WorkPage.CleanScreen.Refresh

'** Copy MainForm to WorkSpace Screen
'** copy the same background picture to the work screen
DestDC = WorkPage.WorkScr.hdc
XPixels = MainForm.ScaleWidth
YPixels = MainForm.ScaleHeight
srcDC = MainForm.hdc
SrcX = 0
SrcY = 0
RasterOp& = SRCCOPY
BitBlt DestDC, 0, 0, XPixels, YPixels, srcDC, SrcX, SrcY, RasterOp
WorkPage.WorkScr.Refresh

'clear these out so they don't take up any space anymore
DestDC = 0
XPixels = 0
YPixels = 0
srcDC = 0
SrcX = 0
SrcY = 0
RasterOp = 0

Randomize (Timer) 'initialize the random number generator

'the following code initializes my sprites
Dim z As Long ' generic to count through the sprites

For z = 0 To SpriteCount - 1  'loop through my sprites and setup ramdom start positions
    With Sprites(z)
        .Xp = Int(Rnd * (RightX - 30)) 'set sprites initial position (horizontal)
        .Yp = Int(Rnd * (BottomY - 30)) 'Set sprites initial position (vertical)
    
        .Xmove = 5 - Int(Rnd * 10) 'this is used to setup a random left or right movement to start with
        .Ymove = 5 - Int(Rnd * 10)  'amount to move vertically
        If .Xmove = 0 Then .Xmove = 1
        If .Ymove = 0 Then .Ymove = 1
        
        .FrIndex = Int(Rnd * 3) 'randomize the starting frames of all the sprites
        .Width = 29  'the width of the sprites used
        .Height = 29 'the height of the sprites used
        .Show = True 'enable the show flag
        .Frames = 4 'amount of frames in sprite
    End With
Next
        
Dim GG As Integer
Dim HH As Integer
Dim VV As Integer

HH = 0
VV = 0
'Fill up the Sprite arrays with the positions of the graphic images in the master graphic
For GG = 0 To 39
    Sprites(GG).ImageSrcX(0) = HH 'first frame (from the Workpage Master Picturebox)
    Sprites(GG).ImageSrcY(0) = VV
    Sprites(GG).ImageSrcX(1) = HH + 30 '2nd frame (workpage master picture box)
    Sprites(GG).ImageSrcY(1) = VV
    Sprites(GG).ImageSrcX(2) = HH + 60 '3rd frame
    Sprites(GG).ImageSrcY(2) = VV
    Sprites(GG).ImageSrcX(3) = HH + 30 '2nd frame (workpage master picture box)
    Sprites(GG).ImageSrcY(3) = VV
    Sprites(GG).ImageMaskX(0) = HH   'first frame mask
    Sprites(GG).ImageMaskY(0) = 233
    Sprites(GG).ImageMaskX(1) = HH + 30 '2nd frame mask
    Sprites(GG).ImageMaskY(1) = 233
    Sprites(GG).ImageMaskX(2) = HH + 60 '3rd frame mask
    Sprites(GG).ImageMaskY(2) = 233
    Sprites(GG).ImageMaskX(3) = HH + 30 '2nd frame mask
    Sprites(GG).ImageMaskY(3) = 233
    HH = HH + 90
    If HH >= 450 Then
        HH = 0
        VV = VV + 29
    End If

Next

'end of sprite initialization
End Sub
