Attribute VB_Name = "CodePage"
Option Explicit
'** Declaration Section - Types
Type Critter                           'Define Sprite User Defined Object
    FrIndex As Integer                 'Current Frame Index
    Xp As Integer                      'X Position on Display Screen
    Yp As Integer                      'Y Postion on Display Screen
    Width As Integer                   'Width of Critter in pixels
    Height As Integer                  'Height of Critter in pixels
    Xmove As Integer                   'Amount to Move Horizontally
    Ymove As Integer                   'amount to move vertically
    Frames As Integer                  'Amount of Frames in Sprite Set
    Show As Boolean                    'Display or not to display (true=display)
    ImageSrcX(3) As Integer            'X Position in Source File Main Image
    ImageSrcY(3) As Integer            'Y Position in Source File Main Graphic
    ImageMaskX(3) As Integer           'X Position in Source File Main Image (Mask)
    ImageMaskY(3) As Integer           'Y Position in Source File Main Graphic (Mask)
End Type

'** Create # of Critter Sprite Objects
Private Sprites(25) As Critter         'Change Number to amount of Sprites needed
Private SpCnt As Integer               'Counter used for Cylcing through Sprites
Public RightX As Integer              'Right Screen Limit
Public BottomY As Integer
Private SpriteCount As Integer         'Critter Set Count
Public ASpeed As Integer              'Animation Speed

'** API declarations
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateDC& Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName$, ByVal lpDeviceName$, ByVal lpOutput$, ByVal lpInitData&)
Private Declare Sub Sleep Lib "kernel32" (ByVal milliseconds As Long)
Private Declare Function StretchBlt& Lib "gdi32" (ByVal hDestDC&, ByVal x&, ByVal y&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal XSrc&, ByVal YSrc&, ByVal nSrcWidth&, ByVal nSrcHeight&, ByVal dwRop&)
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Public Const SRCAND = &H8800C6
Public Const SRCCOPY = &HCC0020
Public Const SRCPAINT = &HEE0086
Public Const NOTSRCCOPY = &H330008

'** BitBlt Variables
Private Ind As Long
Private Xo As Long
Private Yo As Long
Private Xs As Long
Private Ys As Long
Private XSrc As Long
Private YSrc As Long
Private DDC As Long
Private SDC As Long
Private res As Long

Sub CopyScreen(canvas As Object)
Dim screendc&
canvas.AutoRedraw = True
screendc = CreateDC("DISPLAY", "", "", 0&)
StretchBlt canvas.hdc, 0, 0, canvas.Width, canvas.Height, screendc, 0, 0, Screen.Width, Screen.Height, SRCCOPY
DeleteDC screendc
canvas.AutoRedraw = False

End Sub

Sub Main()
  
ASpeed = 15 '**** this will change the speed of the animation (< faster, > slower)
SpriteCount = 10 'the amount of sprites to show on the screen

'Load MainForm

'** copying screen Variables
Dim DestDC As Long               'Destination DC
Dim XPixels As Long              'Transfer Picture Width
Dim YPixels As Long              'Trandfer Picture Height
Dim destX As Long                'Destination X Position
Dim destY As Long                'Destination Y Position
Dim srcDC As Long                'Source DC
Dim SrcX As Long                 'Source X Position
Dim SrcY As Long                 'Source Y Position
Dim RasterOp As Long             'Raster Operation to Perform (Copy, And, Or)

MainForm.Show                       'Bring up the main display form
MainForm.WindowState = 2            ' make sure it's maximized
BottomY = MainForm.ScaleHeight     'Set Bottom Screen Limit
RightX = MainForm.ScaleWidth       'Set Right Screen Limit

CopyScreen MainForm                'Get the Desktop window as a background


'** Make CleanScreen and WorkSpace Screens are the same size as MainForm Screen
WorkPage.CleanScreen.Width = MainForm.Width
WorkPage.CleanScreen.Height = MainForm.Height
WorkPage.WorkScr.Width = MainForm.Width
WorkPage.WorkScr.Height = MainForm.Height
MainForm.Refresh  'Make sure MainForm is current

DoEvents

'** Copy MainForm Page to Clean Screen
'** this saves us a clean background to refresh from when restoring the background undeneath a sprite
DestDC = WorkPage.CleanScreen.hdc
destX = 0
destY = 0
XPixels = MainForm.ScaleWidth
YPixels = MainForm.ScaleHeight
srcDC = MainForm.hdc
SrcX = 0
SrcY = 0
RasterOp& = SRCCOPY
BitBlt DestDC, destX, destY, XPixels, YPixels, srcDC, SrcX, SrcY, RasterOp
WorkPage.CleanScreen.Refresh

'** Copy MainForm to WorkSpace Screen
'** copy the same background picture to the work screen
DestDC = WorkPage.WorkScr.hdc
XPixels = MainForm.ScaleWidth
YPixels = MainForm.ScaleHeight
srcDC = MainForm.hdc
SrcX = 0
SrcY = 0
RasterOp& = SRCCOPY
BitBlt DestDC, 0, 0, XPixels, YPixels, srcDC, SrcX, SrcY, RasterOp
WorkPage.WorkScr.Refresh

'clear these out so they don't take up any space anymore
DestDC = 0
XPixels = 0
YPixels = 0
srcDC = 0
SrcX = 0
SrcY = 0
RasterOp = 0

Randomize (Timer) 'initialize the random number generator

'the following code initializes my sprites
Dim z As Long ' generic to count through the sprites
Dim r As Integer 'Random number from 0 to 5.???

For z = 0 To SpriteCount - 1  'loop through my sprites and setup ramdom start positions
    With Sprites(z)
        .Xp = Int(Rnd * (RightX - 100)) 'set sprites initial position (horizontal)
        .Yp = BottomY - 100 'Set sprites initial position (vertical)
    
        r = Rnd * 6
        If r > 3 Then 'this is used to setup a random left or right movement to start with
            .Xmove = 5
        Else
            .Xmove = -5
        End If
    
        .Ymove = (Rnd * 26) + 10 'amount to move vertically
        .Width = 130  'the width of the sprites used
        .Height = 160 'the height of the sprites used
        .Show = True 'enable the show flag
        .Frames = 3 'not really used in this demo but tells the program how many frames a sprite has
        .ImageSrcX(0) = 0 'xy position of the first frame (from the Workpage Master Picturebox)
        .ImageSrcY(0) = 0
        .ImageSrcX(1) = 130 'xy of 2nd frame (workpage master picture box)
        .ImageSrcY(1) = 0
        .ImageSrcX(2) = 260 'xy of 3rd frame
        .ImageSrcY(2) = 0
    
        .ImageMaskX(0) = 0   'xy of first frame mask
        .ImageMaskY(0) = 160
        .ImageMaskX(1) = 130 'xy of 2nd frame mask
        .ImageMaskY(1) = 160
        .ImageMaskX(2) = 260  'xy of 3rd frame mask
        .ImageMaskY(2) = 160
    
    End With
Next
'end of sprite initialization

Controller  ' Startup the animation (controller routine below)

End Sub
Sub Controller()

Do
'this would normally be set from the registry
DoAnimation 'do it to it
DoEvents 'allows system to check and see if key was pressed or mouse was clicked
If ASpeed > 0 Then Sleep (ASpeed) 'delay to slow down the animation
Loop

End Sub

Sub DoAnimation()

'Reset Background
DDC = WorkPage.WorkScr.hdc
SDC = WorkPage.CleanScreen.hdc

For SpCnt = 0 To SpriteCount ' Erase all Sprites from screen
With Sprites(SpCnt)
    Xo = .Xp
    Yo = .Yp
    Xs = .Width
    Ys = .Height
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, Xo, Yo, SRCCOPY)
End With
Next

For SpCnt = 0 To SpriteCount 'loop through and move each sprite
With Sprites(SpCnt)
    .FrIndex = 0 'default standing position
    If .Ymove < 4 Then .FrIndex = 1 'arms out to side (floating position)
    If .Ymove < 0.9 Then .FrIndex = 2 'arms up (falling position)
    If .Yp > BottomY - 170 Then .FrIndex = 1 'arms out to side (floating position)

    If .Yp >= BottomY - 120 Then
        .Yp = BottomY - 120
        .Ymove = (Rnd * (BottomY / 24)) + 4
        If .Ymove > 36 Then .Ymove = 36
        .Xp = .Xp - .Xmove
    End If
    If .Xp >= RightX - .Width + 24 Then .Xmove = -((.Xmove * Rnd(5)) + 2)
    If .Xp < -24 Then .Xmove = (.Xmove * Rnd(5) + 2)
    
    .Xp = .Xp + .Xmove

    .Yp = .Yp + (.Ymove * -0.95) '-10 if gravity
    .Ymove = .Ymove - 1

    'And mask to WorkScr
    Ind = .FrIndex
    Xo = .Xp
    Yo = .Yp
    Xs = .Width
    Ys = .Height
    XSrc = .ImageMaskX(Ind)
    YSrc = .ImageMaskY(Ind)
    DDC = WorkPage.WorkScr.hdc
    SDC = WorkPage.Master.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCAND)

    'Or image to WorkScr
    XSrc = .ImageSrcX(Ind)
    YSrc = .ImageSrcY(Ind)
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, XSrc, YSrc, SRCPAINT)
End With
Next

'copy all sprites to screen
For SpCnt = 0 To SpriteCount
With Sprites(SpCnt)
    Xo = .Xp
    Yo = .Yp
    Xs = .Width
    Ys = .Height
    DDC = MainForm.hdc
    SDC = WorkPage.WorkScr.hdc
    res = BitBlt(DDC, Xo, Yo, Xs, Ys, SDC, Xo, Yo, SRCCOPY)
End With
Next

End Sub

